VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3570
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3570
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List1 
      Height          =   1185
      Left            =   1440
      Style           =   1  'Checkbox
      TabIndex        =   8
      Top             =   1560
      Width           =   3015
   End
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   1440
      TabIndex        =   6
      Text            =   "Combo2"
      Top             =   1200
      Width           =   3015
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   1440
      TabIndex        =   5
      Text            =   "Combo1"
      Top             =   720
      Width           =   3015
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1440
      TabIndex        =   2
      Text            =   "Text1"
      Top             =   240
      Width           =   3015
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   2880
      TabIndex        =   0
      Top             =   3000
      Width           =   1575
   End
   Begin VB.Label Label4 
      Caption         =   "Flags:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1680
      Width           =   735
   End
   Begin VB.Label Label3 
      Caption         =   "Selected folder:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Root folder:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Dialog title:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Human Readable Names for Shell Folders
Private pVFolders As New Collection

Private Sub Command1_Click()
   Dim lFlags As Long
   Dim vRoot As Variant
   Dim vSelected As Variant
   Dim i As Long
   Dim sPath As String
   
   For i = 0 To List1.ListCount - 1
       If List1.Selected(i) Then
          lFlags = lFlags Or List1.ItemData(i)
       End If
   Next
   If Combo1.ListIndex = -1 Then
      vRoot = Combo1.Text
   Else
      vRoot = Combo1.ItemData(Combo1.ListIndex)
   End If
   If Combo2.ListIndex = -1 Then
      vSelected = Combo2.Text
   Else
      vSelected = Combo2.ItemData(Combo2.ListIndex)
   End If
   sPath = ShowBFDialog(hwnd, Text1.Text, lFlags, vRoot, vSelected)
   If sPath <> "" Then
      MsgBox "You selected [" & sPath & "]"
   Else
      MsgBox "You selected [Nothing]"
   End If
End Sub

Private Sub Form_Initialize()
With pVFolders
   .Add "Desktop", CStr(CSIDL_DESKTOP)
   .Add "Internet", CStr(CSIDL_INTERNET)
   .Add "Program Groups", CStr(CSIDL_PROGRAMS)
   .Add "Control Panel", CStr(CSIDL_CONTROLS)
   .Add "Printers", CStr(CSIDL_PRINTERS)
   .Add "Personal", CStr(CSIDL_PERSONAL)
   .Add "Favorites", CStr(CSIDL_FAVORITES)
   .Add "Startup Menu", CStr(CSIDL_STARTUP)
   .Add "Recent Documents", CStr(CSIDL_RECENT)
   .Add "Send To", CStr(CSIDL_SENDTO)
   .Add "Recycle Bin", CStr(CSIDL_BITBUCKET)
   .Add "Start Menu", CStr(CSIDL_STARTMENU)
   .Add "Desktop Directory", CStr(CSIDL_DESKTOPDIRECTORY)
   .Add "My Computer", CStr(CSIDL_DRIVES)
   .Add "Network Neighborhood Directory", CStr(CSIDL_NETHOOD)
   .Add "Network Neighborhood", CStr(CSIDL_NETWORK)
   .Add "Fonts", CStr(CSIDL_FONTS)
   .Add "Document Templates", CStr(CSIDL_TEMPLATES)
   .Add "Start Menu (All Users)", CStr(CSIDL_COMMON_STARTMENU)
   .Add "Program Groups (All Users)", CStr(CSIDL_COMMON_PROGRAMS)
   .Add "Startup Menu (All Users)", CStr(CSIDL_COMMON_STARTUP)
   .Add "Desktop Directory (All Users)", CStr(CSIDL_COMMON_DESKTOPDIRECTORY)
   .Add "Application Data", CStr(CSIDL_APPDATA)
   .Add "Printer Directory", CStr(CSIDL_PRINTHOOD)
   .Add "Non-Localized Startup Menu", CStr(CSIDL_ALTSTARTUP)
   .Add "Non-Localized Startup Menu (All Users)", CStr(CSIDL_COMMON_ALTSTARTUP)
   .Add "Favorites (All Users)", CStr(CSIDL_COMMON_FAVORITES)
   .Add "Internet Cache", CStr(CSIDL_INTERNET_CACHE)
   .Add "Cookies", CStr(CSIDL_COOKIES)
   .Add "History", CStr(CSIDL_HISTORY)
End With
End Sub

Private Sub Form_Load()
   Text1 = "Select a folder..."
   AddFlags "BIF_RETURNONLYFSDIRS", BIF_RETURNONLYFSDIRS, True
   AddFlags "BIF_DONTGOBELOWDOMAIN", BIF_DONTGOBELOWDOMAIN
   AddFlags "BIF_EDITBOX", BIF_EDITBOX
   AddFlags "BIF_NEWDIALOGSTYLE", BIF_NEWDIALOGSTYLE
   AddFlags "BIF_INCLUDEFILES", BIF_INCLUDEFILES
   AddVirtualFolders Combo1
   AddVirtualFolders Combo2
   Combo1.ListIndex = 0
   Combo2.ListIndex = 14
   Command1.Caption = "Show dialog"
End Sub

Private Sub AddFlags(ByVal sName As String, lVal As Long, Optional bChecked As Boolean)
   List1.AddItem sName
   List1.ItemData(List1.NewIndex) = lVal
   List1.Selected(List1.NewIndex) = bChecked
End Sub

Private Sub AddVirtualFolders(cb As ComboBox)
   With cb
      .AddItem pVFolders(CStr(CSIDL_DESKTOP))
      .ItemData(.NewIndex) = CSIDL_DESKTOP
      .AddItem pVFolders(CStr(CSIDL_INTERNET))
      .ItemData(.NewIndex) = CSIDL_INTERNET
      .AddItem pVFolders(CStr(CSIDL_PROGRAMS))
      .ItemData(.NewIndex) = CSIDL_PROGRAMS
      .AddItem pVFolders(CStr(CSIDL_CONTROLS))
      .ItemData(.NewIndex) = CSIDL_CONTROLS
      .AddItem pVFolders(CStr(CSIDL_PRINTERS))
      .ItemData(.NewIndex) = CSIDL_PRINTERS
      .AddItem pVFolders(CStr(CSIDL_PERSONAL))
      .ItemData(.NewIndex) = CSIDL_PERSONAL
      .AddItem pVFolders(CStr(CSIDL_FAVORITES))
      .ItemData(.NewIndex) = CSIDL_FAVORITES
      .AddItem pVFolders(CStr(CSIDL_STARTUP))
      .ItemData(.NewIndex) = CSIDL_STARTUP
      .AddItem pVFolders(CStr(CSIDL_RECENT))
      .ItemData(.NewIndex) = CSIDL_RECENT
      .AddItem pVFolders(CStr(CSIDL_SENDTO))
      .ItemData(.NewIndex) = CSIDL_SENDTO
      .AddItem pVFolders(CStr(CSIDL_BITBUCKET))
      .ItemData(.NewIndex) = CSIDL_BITBUCKET
      .AddItem pVFolders(CStr(CSIDL_STARTMENU))
      .ItemData(.NewIndex) = CSIDL_STARTMENU
      .AddItem pVFolders(CStr(CSIDL_DESKTOPDIRECTORY))
      .ItemData(.NewIndex) = CSIDL_DESKTOPDIRECTORY
      .AddItem pVFolders(CStr(CSIDL_DRIVES))
      .ItemData(.NewIndex) = CSIDL_DRIVES
      .AddItem pVFolders(CStr(CSIDL_NETWORK))
      .ItemData(.NewIndex) = CSIDL_NETWORK
      .AddItem pVFolders(CStr(CSIDL_NETHOOD))
      .ItemData(.NewIndex) = CSIDL_NETHOOD
      .AddItem pVFolders(CStr(CSIDL_FONTS))
      .ItemData(.NewIndex) = CSIDL_FONTS
      .AddItem pVFolders(CStr(CSIDL_TEMPLATES))
      .ItemData(.NewIndex) = CSIDL_TEMPLATES
      .AddItem pVFolders(CStr(CSIDL_COMMON_STARTMENU))
      .ItemData(.NewIndex) = CSIDL_COMMON_STARTMENU
      .AddItem pVFolders(CStr(CSIDL_COMMON_PROGRAMS))
      .ItemData(.NewIndex) = CSIDL_COMMON_PROGRAMS
      .AddItem pVFolders(CStr(CSIDL_COMMON_STARTUP))
      .ItemData(.NewIndex) = CSIDL_COMMON_STARTUP
      .AddItem pVFolders(CStr(CSIDL_COMMON_DESKTOPDIRECTORY))
      .ItemData(.NewIndex) = CSIDL_COMMON_DESKTOPDIRECTORY
      .AddItem pVFolders(CStr(CSIDL_APPDATA))
      .ItemData(.NewIndex) = CSIDL_APPDATA
      .AddItem pVFolders(CStr(CSIDL_PRINTHOOD))
      .ItemData(.NewIndex) = CSIDL_PRINTHOOD
      .AddItem pVFolders(CStr(CSIDL_ALTSTARTUP))
      .ItemData(.NewIndex) = CSIDL_ALTSTARTUP
      .AddItem pVFolders(CStr(CSIDL_COMMON_ALTSTARTUP))
      .ItemData(.NewIndex) = CSIDL_COMMON_ALTSTARTUP
      .AddItem pVFolders(CStr(CSIDL_COMMON_FAVORITES))
      .ItemData(.NewIndex) = CSIDL_COMMON_FAVORITES
      .AddItem pVFolders(CStr(CSIDL_INTERNET_CACHE))
      .ItemData(.NewIndex) = CSIDL_INTERNET_CACHE
      .AddItem pVFolders(CStr(CSIDL_COOKIES))
      .ItemData(.NewIndex) = CSIDL_COOKIES
      .AddItem pVFolders(CStr(CSIDL_HISTORY))
      .ItemData(.NewIndex) = CSIDL_HISTORY
   End With
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set pVFolders = Nothing
End Sub
